           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_SKIP = Csp_semantics:

(*****************************************************************

         1. SKIPt  : dom_T
         2. SKIPf  : dom_F
         3. SKIPsf : dom_SF
         4. 

 *****************************************************************)

(*********************************************************
               Lemmas (SKIPsf in Dom_SF)
 *********************************************************)

(*** SKIPt in dom_T ***)

lemma SKIPt_in : "SKIPt: dom_T"
apply (simp add: SKIPt_def)
apply (simp add: one_t_set_in)
done

(*** SKIPf in dom_F ***)

lemma SKIPf_in : "SKIPf: dom_F"
apply (simp add: SKIPf_def)
apply (simp add: nil_Tick_t_in_dom_F)
done

(*******************************
       SKIPsf in dom_SF 
 *******************************)

(* T2 *)

lemma SKIPsf_in_T2 : "CT2 SKIPsf"
apply (simp add: SKIPsf_def CT2_def)
apply (intro allI impI)
apply (simp add: SKIPt_in Abs_dom_T_inverse)
apply (simp add: SKIPf_in Abs_dom_F_inverse)

apply (simp add: SKIPt_def SKIPf_def)

apply (erule conjE)
apply (erule disjE)

apply (simp add: app_t_nil)

apply (simp add: appt_to_app_or_sym)
apply (simp add: Abs_Rep_t_inv nil_in_trace)
apply (simp add: Rep_trace_inverse)
done

(* F2 *)

lemma SKIPsf_in_F2 : "CF2 SKIPsf"
apply (simp add: SKIPsf_def CF2_def)
apply (intro allI impI)
apply (simp add: SKIPt_in Abs_dom_T_inverse)
apply (simp add: SKIPf_in Abs_dom_F_inverse)

apply (simp add: SKIPt_def SKIPf_def)
apply (erule conjE)
apply (erule disjE)

  (* s=[] *)

apply (case_tac "Tick : Y")

    (* if Tick:Y then it is inconsist *)

apply (erule conjE)
apply (drule_tac x="Tick" in spec)
apply (simp add: appt_to_app_or_sym)
apply (simp add: nil_in_trace Abs_trace_inverse)

    (* so Tick~:Y *)

apply (simp add: Evset_def)
apply (rule disjI1)
apply (rule subsetI)
apply (simp)

apply (simp add: subset_def)
apply (simp add: Ball_def)
apply (erule conjE)+
apply (rotate_tac -1)
apply (drule_tac x="x" in spec)
apply (erule disjE)
apply (simp)

apply (case_tac "x = Tick")
apply (simp)
apply (simp)

  (* s=Tick *)

apply (simp add: EvsetTick_def)
done

(* F3 *)

lemma SKIPsf_in_F3 : "CF3 SKIPsf"
apply (simp add: SKIPsf_def CF3_def)
apply (intro allI impI)
apply (simp add: SKIPt_in Abs_dom_T_inverse)
apply (simp add: SKIPf_in Abs_dom_F_inverse)

apply (auto simp add: SKIPt_def SKIPf_def)
done

(*** SKIPsf in dom_SF ***)

lemma SKIPsf_in : "SKIPsf: dom_SF"
apply (simp add: dom_SF_def)
apply (simp add: SKIPsf_in_T2)
apply (simp add: SKIPsf_in_F2)
apply (simp add: SKIPsf_in_F3)
done

(*********************************************************
                  SKIP trace eval
 *********************************************************)

lemma SKIPt_eval: "ALL ev. [[SKIP]]T ev = SKIPt"
apply (intro allI)
apply (simp add: eval_T_def)
apply (simp add: SKIPsf_def)
apply (simp add: SKIPt_in Abs_dom_T_inverse)
done

(*********************************************************
                  SKIP failure eval
 *********************************************************)

lemma SKIPf_eval: "ALL ev. [[SKIP]]F ev = SKIPf"
apply (intro allI)
apply (simp add: eval_F_def)
apply (simp add: SKIPsf_def)
apply (simp add: SKIPf_in Abs_dom_F_inverse)
done

end
