           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                August 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_law_SKIP = Csp_law_decompo:

(*****************************************************************

         1. SKIP ;; P
         2. P ;; SKIP
         3. SKIP |[X]| P
         4. P |[X]| SKIP
         5. SKIP |[X]| SKIP
         6. SKIP -- X
         7. SKIP [[r]]

 *****************************************************************)

(*********************************************************
                       SKIP ;; P
 *********************************************************)

lemma csp_Sequence_unit_l: "LET df IN SKIP ;; P =F[af] LET df IN P"
apply (simp add: eqsf_iff eq_Sequence_unit_l)
done

(*********************************************************
                       P ;; SKIP
 *********************************************************)

lemma csp_Sequence_unit_r: "LET df IN P ;; SKIP =F[af] LET df IN P"
apply (simp add: eqsf_iff eq_Sequence_unit_r)
done

(*********************************************************
                      SKIP |[X]| P
 *********************************************************)

lemma csp_Parallel_preterm_l: 
   "LET df IN SKIP |[X]| (? :Y -> Qf)
    =F[af] LET df IN ? x:(Y-X) -> (SKIP |[X]| Qf x)"
apply (simp add: eqsf_iff eq_Parallel_preterm_l)
done

(*********************************************************
                      P |[X]| SKIP
 *********************************************************)

lemma csp_Parallel_preterm_r: 
   "LET df IN (? :Y -> Pf) |[X]| SKIP
    =F[af] LET df IN ? x:(Y-X) -> (Pf x |[X]| SKIP)"
apply (simp add: eqsf_iff eq_Parallel_preterm_r)
done

(*********************************************************
                    SKIP |[X]| SKIP
 *********************************************************)

lemma csp_Parallel_term: 
   "LET df IN SKIP |[X]| SKIP =F[af] LET df IN SKIP"
apply (simp add: eqsf_iff eq_Parallel_term)
done

(*********************************************************
                      SKIP -- X
 *********************************************************)

lemma csp_SKIP_Hide_Id: 
   "LET df IN SKIP -- X =F[af] LET df IN SKIP"
apply (simp add: eqsf_iff eq_SKIP_Hide_Id)
done

(*********************************************************
                      SKIP [[r]]
 *********************************************************)

lemma csp_SKIP_Rename_Id: 
   "LET df IN SKIP [[r]] =F[af] LET df IN SKIP"
apply (simp add: eqsf_iff eq_SKIP_Rename_Id)
done

(*********************************************************
                       SKIP laws
 *********************************************************)

lemmas csp_SKIP = csp_Sequence_unit_l csp_Sequence_unit_r
                      csp_Parallel_preterm_l csp_Parallel_preterm_r
                      csp_Parallel_term csp_SKIP_Hide_Id
                      csp_SKIP_Rename_Id

lemmas csp_SKIP_rw_left_eq   = csp_SKIP[THEN csp_rule_rw_left_eq]
lemmas csp_SKIP_rw_left_ref  = csp_SKIP[THEN csp_rule_rw_left_ref]
lemmas csp_SKIP_rw_right_eq  = csp_SKIP[THEN csp_rule_rw_right_eq]
lemmas csp_SKIP_rw_right_ref = csp_SKIP[THEN csp_rule_rw_right_ref]

lemmas csp_SKIP_rw_left      = csp_SKIP_rw_left_eq csp_SKIP_rw_left_ref
lemmas csp_SKIP_rw_right     = csp_SKIP_rw_right_eq csp_SKIP_rw_right_ref

lemmas csp_SKIP_rw           = csp_SKIP_rw_left csp_SKIP_rw_right

end
