           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Ext_choice = Csp_Ext_choice:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*****************************************************************

         1. EXTCHsf SF : non-expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                  rest Ext_choicet
 *********************************************************)

(*** (<=) ***)

lemma rest_Ext_choicet_sub :
  "ALL f g SETFs n. SETFs ~= {} &
    (ALL SETF:SETFs. (f SETF) rest n = 
                     (g SETF) rest n)
     --> (UnionT (fst ` f ` SETFs)) rest n 
      <= (UnionT (fst ` g ` SETFs)) rest n"
apply (intro allI impI)
apply (simp add: pair_restriction_def)

apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse Abs_dom_T_inject)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Ext_choicet_in_rep Abs_dom_T_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (elim conjE bexE)

apply (drule_tac x="xa" in bspec, simp)
apply (simp add: Collect_open)
apply (erule conjE)
apply (drule_tac x="x" in spec)
apply (rule_tac x="xa" in bexI)
apply (simp)
apply (simp)
done

(*** (=) ***)

lemma rest_Ext_choicet :
  "ALL f g SETFs n. SETFs ~= {} &
    (ALL SETF:SETFs. (f SETF) rest n = 
                     (g SETF) rest n)
     --> (UnionT (fst ` f ` SETFs)) rest n 
       = (UnionT (fst ` g ` SETFs)) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Ext_choicet_sub)
done

(*********************************************************
                  rest Ext_choicef
 *********************************************************)

(*** (<=) non_zero ***)

lemma rest_Ext_choicef_non_zero :
  "ALL f g SETFs n. 0 < n &
    (ALL SETF:SETFs. (f SETF) rest n = (g SETF) rest n) 
   --> Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` f ` SETFs) 
                         (Rep_dom_F ` snd ` f ` SETFs)) rest n 
    <= Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` g ` SETFs) 
                         (Rep_dom_F ` snd ` g ` SETFs)) rest n"
apply (intro allI impI)
apply (simp add: pair_restriction_def)

apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse Abs_dom_F_inject)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Ext_choicef_in_rep Abs_dom_F_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (rename_tac f g SETFs n s X)
apply (simp add: Ext_choicef_def)

   (* s = []t & (ALL x:SETFs. ([]t, X) :f right (f x)) *)

apply (erule conjE)
apply (erule disjE)
apply (rule disjI1)

apply (simp)
apply (intro ballI)
apply (rename_tac f g SETFs n s X SETF)

apply (drule_tac x="SETF" in bspec, simp)

apply (erule conjE)+
apply (simp add: Collect_open)
apply (drule_tac x="[]t" in spec)
apply (drule_tac x="X" in spec)
apply (simp add: nil_in_trace Abs_trace_inverse)

   (* s ~= []t & (EX x:SETFs. (s, X) :f right (f x)) *)

apply (rotate_tac -1)
apply (erule disjE)
apply (rule disjI2)
apply (rule disjI1)

apply (simp)
apply (elim conjE bexE)
apply (rename_tac f g SETFs n s X SETF)

apply (drule_tac x="SETF" in bspec, simp)

apply (erule conjE)+
apply (simp add: Collect_open)
apply (drule_tac x="s" in spec)
apply (drule_tac x="X" in spec)
apply (rule_tac x="SETF" in bexI)
apply (simp)
apply (simp)

   (* s = []t & X <= Evset & (EX x:SETFs. [Tick]t :t fst (f x)) *)

apply (rule disjI2)
apply (rule disjI2)

apply (simp)
apply (elim conjE bexE)
apply (rename_tac f g SETFs n s X SETF)

apply (drule_tac x="SETF" in bspec, simp)

       (* unfold restT *)

apply (simp add: rest_T_def)
apply (simp add: restTset_in Abs_dom_T_inject)
apply (simp add: restTset_def)

apply (simp add: Collect_open)
apply (erule conjE)
apply (drule_tac x="[Tick]t" in spec)
apply (rule_tac x="SETF" in bexI)
apply (simp add: event_in_trace Abs_trace_inverse)
apply (simp)
done

(*** (=) ***)

lemma rest_Ext_choicef :
  "ALL f g SETFs n.
    (ALL SETF:SETFs. (f SETF) rest n = (g SETF) rest n) 
   --> Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` f ` SETFs) 
                         (Rep_dom_F ` snd ` f ` SETFs)) rest n 
     = Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` g ` SETFs) 
                         (Rep_dom_F ` snd ` g ` SETFs)) rest n"
apply (intro allI impI)

apply (case_tac "n = 0")
apply (simp add: zero_eq_rs)

      (* 0 < n *)
apply (rule order_antisym)
apply (simp_all add: rest_Ext_choicef_non_zero)
done

(*********************************************************
                      dis Ext_choicet
 *********************************************************)

lemma dis_Ext_choicet:
  "ALL SETFs. SETFs ~= {} 
       --> (EX SETF. SETF : SETFs &
       distance(UnionT (fst ` fst ` SETFs),
                UnionT (fst ` snd ` SETFs))
       <= distance(fst SETF, snd SETF))"
apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="SETFs" in spec)
apply (drule_tac x="UnionT (fst ` fst ` SETFs)" in spec)
apply (drule_tac x="UnionT (fst ` snd ` SETFs)" in spec)
apply (simp add: rest_Ext_choicet)
done

(*********************************************************
                      dis Ext_choicef
 *********************************************************)

lemma dis_Ext_choicef:
  "ALL SETFs. SETFs ~= {}
       --> (EX SETF. SETF : SETFs &
   distance(Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` fst ` SETFs)
                              (Rep_dom_F ` snd ` fst ` SETFs)),
            Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` snd ` SETFs) 
                              (Rep_dom_F ` snd ` snd ` SETFs)))
       <= distance(fst SETF, snd SETF))"
apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="SETFs" in spec)
apply (drule_tac x=
     "Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` fst ` SETFs)
                        (Rep_dom_F ` snd ` fst ` SETFs))"
     in spec)
apply (drule_tac x=
     "Abs_dom_F (EXTCHf (Rep_dom_T ` fst ` snd ` SETFs) 
                        (Rep_dom_F ` snd ` snd ` SETFs))"
     in spec)
apply (simp add: rest_Ext_choicef)
done

(*********************************************************
                      dis Ext_choicesf
 *********************************************************)

declare split_paired_All [simp del]
declare split_paired_Ex  [simp del]

   (* these rules are deleted only for this lemma dis_Ext_choicesf *)
   (*                                                              *)
   (* note: split_paired_All: (ALL x. ?P x) = (ALL a b. ?P (a, b)) *)
   (*       split_paired_Ex : (EX x. ?P x) = (EX a b. ?P (a, b))   *)

lemma dis_Ext_choicesf:
  "ALL SETFs. SETFs ~= {} 
       --> (EX SETF. SETF : SETFs &
             distance(EXTCHsf (fst ` SETFs), EXTCHsf (snd ` SETFs)) 
          <= distance(fst SETF, snd SETF))"
apply (intro allI impI)
apply (simp add: Ext_choicesf_def)
apply (simp add: pair_distance)

      (* dom_T part *)
apply (insert dis_Ext_choicet)
apply (drule_tac x="SETFs" in spec)
apply (simp)
apply (elim conjE exE)

      (* dom_F part *)
apply (insert dis_Ext_choicef)
apply (drule_tac x="SETFs" in spec)
apply (simp)
apply (elim conjE exE)
apply (rename_tac SETFs SETF SETF')

  (* solve max *)

apply (case_tac "distance (fst SETF, snd SETF)
              <= distance (fst SETF', snd SETF')")

      (* distance SETF <= distance SETF' *)
apply (rule_tac x="SETF'" in exI)
apply (simp add: pair_distance_inv)

      (* distance SETF' <= distance SETF *)
apply (rule_tac x="SETF" in exI)
apply (simp add: pair_distance_inv)
done

declare split_paired_All [simp add]
declare split_paired_Ex  [simp add]

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]

end
