           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Int_choice = Csp_Int_choice + Csp_map_Ext_choice:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*****************************************************************

         1. INTCHsf SF : non-expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                  rest Int_choicef
 *********************************************************)

(*** (<=) ***)

lemma rest_Int_choicef_sub :
  "ALL f g SETFs n. SETFs ~= {} &
    (ALL SETF:SETFs. (f SETF) rest n = 
                     (g SETF) rest n)
     --> (UnionF (snd ` f ` SETFs)) rest n 
      <= (UnionF (snd ` g ` SETFs)) rest n"
apply (intro allI impI)
apply (simp add: pair_restriction_def)

apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse Abs_dom_F_inject)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Int_choicef_in_rep Abs_dom_F_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (elim conjE bexE)

apply (drule_tac x="x" in bspec, simp)
apply (simp add: Collect_open)
apply (erule conjE)
apply (drule_tac x="a" in spec)
apply (drule_tac x="b" in spec)
apply (rule_tac x="x" in bexI)
apply (simp)
apply (simp)
done

(*** (=) ***)

lemma rest_Int_choicef :
  "ALL f g SETFs n. SETFs ~= {} &
    (ALL SETF:SETFs. (f SETF) rest n = 
                     (g SETF) rest n)
     --> (UnionF (snd ` f ` SETFs)) rest n 
       = (UnionF (snd ` g ` SETFs)) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Int_choicef_sub)
done

(*********************************************************
                      dis Int_choicef
 *********************************************************)

lemma dis_Int_choicef:
  "ALL SETFs. SETFs ~= {} 
       --> (EX SETF. SETF : SETFs &
       distance(UnionF (snd ` fst ` SETFs),
                UnionF (snd ` snd ` SETFs))
       <= distance(fst SETF, snd SETF))"
apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="SETFs" in spec)
apply (drule_tac x="UnionF (snd ` fst ` SETFs)" in spec)
apply (drule_tac x="UnionF (snd ` snd ` SETFs)" in spec)
apply (simp add: rest_Int_choicef)
done

(*********************************************************
                      dis Int_choicesf
 *********************************************************)

declare split_paired_All [simp del]
declare split_paired_Ex  [simp del]

   (* these rules are deleted only for this lemma dis_Ext_choicesf *)
   (*                                                              *)
   (* note: split_paired_All: (ALL x. ?P x) = (ALL a b. ?P (a, b)) *)
   (*       split_paired_Ex : (EX x. ?P x) = (EX a b. ?P (a, b))   *)

lemma dis_Int_choicesf:
  "ALL SETFs. SETFs ~= {} 
       --> (EX SETF. SETF : SETFs &
             distance(INTCHsf (fst ` SETFs), INTCHsf (snd ` SETFs)) 
          <= distance(fst SETF, snd SETF))"
apply (intro allI impI)
apply (simp add: Int_choicesf_def)
apply (simp add: pair_distance)

      (* dom_T part *)

apply (insert dis_Ext_choicet)
apply (drule_tac x="SETFs" in spec)
apply (simp)
apply (elim conjE exE)

      (* dom_F part *)
apply (insert dis_Int_choicef)
apply (drule_tac x="SETFs" in spec)
apply (simp)
apply (elim conjE exE)
apply (rename_tac SETFs SETF SETF')

  (* solve max *)

apply (case_tac "distance (fst SETF, snd SETF) 
              <= distance (fst SETF', snd SETF')")

      (* distance T <= distance F *)
apply (rule_tac x="SETF'" in exI)
apply (simp add: pair_distance_inv)

      (* distance T => distance F *)
apply (rule_tac x="SETF" in exI)
apply (simp add: pair_distance_inv)
done

declare split_paired_All [simp add]
declare split_paired_Ex  [simp add]

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]

end
