           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_map_Parallel = Csp_Parallel:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite (notick | t = []t)                 *)
(*                                                                     *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*****************************************************************

         1. SF |[X]|sf SF : non-expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                    rest Parallelt
 *********************************************************)

(*** (<=) ***)

lemma rest_Parallelt_sub :
  "ALL X S1 S2 T1 T2 n. S1:dom_T & S2:dom_T & T1:dom_T & T2:dom_T &
        (Abs_dom_T S1) rest n <= (Abs_dom_T T1) rest n &
        (Abs_dom_T S2) rest n <= (Abs_dom_T T2) rest n
     --> Abs_dom_T (S1 |[X]|t S2) rest n <= 
         Abs_dom_T (T1 |[X]|t T2) rest n"

apply (intro allI impI)
apply (simp add: rest_T_def)
apply (simp add: subset_T_def)
apply (simp add: restTset_in Abs_dom_T_inverse)
apply (simp add: restTset_def)
apply (erule conjE)+
apply (simp add: Parallelt_in Abs_dom_T_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (simp add: Parallelt_def)
apply (elim conjE exE)
apply (rename_tac X S1 S2 T1 T2 n u st s t)

apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)
apply (simp)
apply (insert par_trace_length)
apply (drule_tac x="X" in spec)
apply (drule_tac x="u" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)

apply (rule_tac x="st" in exI)
apply (simp)

apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)
apply (blast intro: order_trans)
done

(*** (=) ***)

lemma rest_Parallelt :
  "ALL X S1 S2 T1 T2 n. S1:dom_T & S2:dom_T & T1:dom_T & T2:dom_T &
        (Abs_dom_T S1) rest n = (Abs_dom_T T1) rest n &
        (Abs_dom_T S2) rest n = (Abs_dom_T T2) rest n
     --> Abs_dom_T (S1 |[X]|t S2) rest n = 
         Abs_dom_T (T1 |[X]|t T2) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Parallelt_sub)
done

(*********************************************************
                    rest Parallelf
 *********************************************************)

(*** (<=) ***)

lemma rest_Parallelf_sub :
  "ALL X E1 E2 F1 F2 n. E1:dom_F & E2:dom_F & F1:dom_F & F2:dom_F &
        (Abs_dom_F E1) rest n <= (Abs_dom_F F1) rest n &
        (Abs_dom_F E2) rest n <= (Abs_dom_F F2) rest n
     --> Abs_dom_F (E1 |[X]|f E2) rest n <= 
         Abs_dom_F (F1 |[X]|f F2) rest n"

apply (intro allI impI)
apply (simp add: rest_F_def)
apply (simp add: subset_F_def)
apply (simp add: restFset_in Abs_dom_F_inverse)
apply (simp add: restFset_def)
apply (erule conjE)+
apply (simp add: Parallelf_in Abs_dom_F_inverse)

apply (simp add: subset_def)
apply (intro allI impI)
apply (simp add: Parallelf_def)
apply (elim conjE exE)
apply (rename_tac X E1 E2 F1 F2 n u Z Y1 Y2 s t)

apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)
apply (drule_tac x="Y1" in spec)
apply (drule_tac x="Y2" in spec)
apply (simp)

apply (insert par_trace_length)
apply (drule_tac x="X" in spec)
apply (drule_tac x="u" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)
apply (simp)

apply (rule_tac x="Y1" in exI)
apply (rule_tac x="Y2" in exI)
apply (simp)
apply (rule_tac x="s" in exI)
apply (rule_tac x="t" in exI)
apply (simp)

       (* lengtht u < n *)

apply (erule disjE)
apply (erule conjE)+
apply (simp)

       (* lengtht u = n & (EX s'. u = s' @t [Tick]t & notick s') *)

apply (elim conjE exE)
apply (rename_tac X E1 E2 F1 F2 n u Z Y1 Y2 s t u')
apply (simp)

       (* decompo u @ [Tick] --> s t *)

apply (insert par_trace_last_only_if)
apply (drule_tac x="X" in spec)
apply (drule_tac x="u'" in spec)
apply (drule_tac x="Tick" in spec)
apply (drule_tac x="s" in spec)
apply (drule_tac x="t" in spec)
apply (simp)
apply (elim conjE exE)

apply (case_tac "lengtht t = n")

          (* lengtht t = n *)

apply (case_tac "lengtht s = n")

              (* lengtht s = n *)

apply (simp)
apply (drule mp)
apply (rule_tac x="s'" in exI)
apply (simp)
apply (drule mp)
apply (rule_tac x="t'" in exI)
apply (simp)
apply (simp)

              (* lengtht s < n *)

apply (simp)
apply (drule mp)
apply (rule_tac x="t'" in exI)
apply (simp)
apply (simp)

          (* lengtht t < n *)

apply (case_tac "lengtht s = n")

              (* lengtht s = n *)

apply (simp)
apply (drule mp)
apply (rule_tac x="s'" in exI)
apply (simp)
apply (simp)

              (* lengtht s < n *)

apply (simp)
done

(*** (=) ***)

lemma rest_Parallelf :
  "ALL X E1 E2 F1 F2 n. E1:dom_F & E2:dom_F & F1:dom_F & F2:dom_F &
        (Abs_dom_F E1) rest n = (Abs_dom_F F1) rest n &
        (Abs_dom_F E2) rest n = (Abs_dom_F F2) rest n
     --> Abs_dom_F (E1 |[X]|f E2) rest n = 
         Abs_dom_F (F1 |[X]|f F2) rest n"
apply (intro allI impI)
apply (rule order_antisym)
apply (simp_all add: rest_Parallelf_sub)
done

(*********************************************************
                      dis Parallelt
 *********************************************************)

lemma dis_Parallelt:
  "ALL X S1 S2 T1 T2.
       distance(Abs_dom_T (Rep_dom_T S1 |[X]|t Rep_dom_T S2), 
                Abs_dom_T (Rep_dom_T T1 |[X]|t Rep_dom_T T2))
       <= max (distance(S1, T1)) (distance(S2, T2))"

apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(S1,T1), (S2,T2)}" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T S1 |[X]|t Rep_dom_T S2)" in spec)
apply (drule_tac x="Abs_dom_T (Rep_dom_T T1 |[X]|t Rep_dom_T T2)" in spec)
apply (insert rest_Parallelt)
apply (drule_tac x="X" in spec)
apply (drule_tac x="Rep_dom_T S1" in spec)
apply (drule_tac x="Rep_dom_T S2" in spec)
apply (drule_tac x="Rep_dom_T T1" in spec)
apply (drule_tac x="Rep_dom_T T2" in spec)
apply (simp add: Rep_dom_T Rep_dom_T_inverse)
apply (auto simp add: max_def)
done

(*********************************************************
                      dis Parallelf
 *********************************************************)

lemma dis_Parallelf:
  "ALL X E1 E2 F1 F2.
       distance(Abs_dom_F (Rep_dom_F E1 |[X]|f Rep_dom_F E2), 
                Abs_dom_F (Rep_dom_F F1 |[X]|f Rep_dom_F F2))
       <= max (distance(E1, F1)) (distance(E2, F2))"

apply (intro allI impI)
apply (insert rest_to_dis_exists_pair)
apply (drule_tac x="(%x. x)" in spec)
apply (drule_tac x="{(E1,F1), (E2,F2)}" in spec)
apply (drule_tac x="Abs_dom_F (Rep_dom_F E1 |[X]|f Rep_dom_F E2)" in spec)
apply (drule_tac x="Abs_dom_F (Rep_dom_F F1 |[X]|f Rep_dom_F F2)" in spec)
apply (insert rest_Parallelf)
apply (drule_tac x="X" in spec)
apply (drule_tac x="Rep_dom_F E1" in spec)
apply (drule_tac x="Rep_dom_F E2" in spec)
apply (drule_tac x="Rep_dom_F F1" in spec)
apply (drule_tac x="Rep_dom_F F2" in spec)
apply (simp add: Rep_dom_F Rep_dom_F_inverse)
apply (auto simp add: max_def)
done

(*********************************************************
                      dis Parallelsf
 *********************************************************)

lemma dis_Parallelsf:
  "ALL X SE1 TF1 SE2 TF2.
       distance(SE1 |[X]|sf SE2, TF1 |[X]|sf TF2)
       <= max (distance(SE1, TF1)) (distance(SE2, TF2))"
apply (intro allI impI)
apply (simp add: Parallelsf_def)
apply (simp add: pair_distance)

      (* dom_T part *)

apply (insert dis_Parallelt)
apply (drule_tac x="X" in spec)
apply (drule_tac x="fst SE1" in spec)
apply (drule_tac x="fst SE2" in spec)
apply (drule_tac x="fst TF1" in spec)
apply (drule_tac x="fst TF2" in spec)

      (* dom_F part *)

apply (insert dis_Parallelf)
apply (drule_tac x="X" in spec)
apply (drule_tac x="snd SE1" in spec)
apply (drule_tac x="snd SE2" in spec)
apply (drule_tac x="snd TF1" in spec)
apply (drule_tac x="snd TF2" in spec)

  (* solve max *)

apply (case_tac "distance (fst SE1, fst TF1)
              <= distance (fst SE2, fst TF2)")

apply (case_tac "distance (snd SE1, snd TF1)
              <= distance (snd SE2, snd TF2)")

apply (simp add: max_x_y max_y_x)
apply (simp add: max_def)

apply (simp add: max_x_y max_y_x)
apply (simp add: max_def)

apply (case_tac "distance (snd SE1, snd TF1)
              <= distance (snd SE2, snd TF2)")

apply (simp add: max_x_y max_y_x)
apply (simp add: max_def)

apply (simp add: max_x_y max_y_x)
apply (simp add: max_def)
done


(****************** to add it again ******************)

declare disj_not1 [simp] 

end
