           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_Int = Csp_relation_def:

(*****************************************************************

         1. Internal properties
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                      refinement
 *********************************************************)

(*** or_1 <= ***)

lemma ref_Int_choice_left1:
  "P1 <=F<ev> Q ==> (P1 |~| P2) <=F<ev> Q"
apply (simp add: refsf_decompo)
apply (simp add: Int_choicet_eval)
apply (simp add: Int_choicef_eval)
apply (blast)
done

(*** or_2 <= ***)

lemma ref_Int_choice_left2:
  "P2 <=F<ev> Q ==> (P1 |~| P2) <=F<ev> Q"
apply (simp add: refsf_decompo)
apply (simp add: Int_choicet_eval)
apply (simp add: Int_choicef_eval)
apply (blast)
done

(*** <= and ***)

lemma ref_Int_choice_right:
  "P <=F<ev> Q1 & P <=F<ev> Q2
        ==> P <=F<ev> (Q1 |~| Q2)"
apply (simp add: refsf_decompo)
apply (simp add: Int_choicet_eval)
apply (simp add: Int_choicef_eval)
apply (blast)
done

(*** EX <= ***)

lemma ref_Int_bind_left:
  "[| x:X ; Pf x <=F<ev> Q |] ==> ! :X .. Pf <=F<ev> Q"
apply (simp add: refsf_decompo)
apply (simp add: Int_bindt_eval)
apply (simp add: Int_bindf_eval)
apply (blast)
done

(*** <= ALL ***)

lemma ref_Int_bind_right:
  "(!! a. a:X ==> P <=F<ev> Qf a) ==> P <=F<ev> ! :X .. Qf"
apply (simp add: refsf_decompo)
apply (simp add: Int_bindt_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: eval_T_in nil_t_in_all_dom)
apply (blast)
done

(*** EX <= ALL ***)

lemma ref_Int_bind_subset:
  "Y <= X ==> ! :X .. Pf <=F<ev> ! :Y .. Pf"
apply (simp add: refsf_decompo)
apply (simp add: Int_bindt_eval)
apply (simp add: Int_bindf_eval)
apply (blast)
done

(*** |~| and [+] ***)

lemma ref_Int_choice_Ext_choice:
  "(P1 |~| P2) <=F<ev> (P1 [+] P2)"
apply (simp add: refsf_decompo)
apply (simp add: Int_choicet_eval Ext_choicet_eval)
apply (simp add: Int_choicef_eval Ext_choicef_eval)

apply (rule subsetI)
apply (simp)
apply (erule disjE)
apply (elim conjE exE)
apply (simp)

apply (erule disjE)
apply (simp add: pair_fun_apply)
apply (elim conjE exE)

apply (erule disjE)
apply (simp_all add: T2_F1_Tick)
done

(*** ! x:X .. and ? -> ***)

lemma ref_Int_bind_Pre_choice:
  "X ~={}
      ==> ! x:X .. (x -> Pf x) <=F<ev> ? :X -> Pf"
apply (simp add: refsf_decompo)
apply (rule conjI)

      (* T *)

apply (simp add: Int_bindt_eval Pre_choicet_eval)
apply (simp add: Prefixt_eval)
apply (simp add: Prefixt_def)
apply (rule subsetI)
apply (simp)
apply (elim conjE exE)
apply (rule disjI2)
apply (rule_tac x="insert []t {[Ev a]t @t s |s. s : [[Pf a]]T ev}" in exI)
apply (simp)
apply (rule conjI)
apply (rule_tac x="a" in exI)
apply (simp)

apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (simp)

      (* F *)

apply (simp add: Int_bindf_eval Pre_choicef_eval)
apply (rule subsetI)
apply (simp)

apply (erule disjE)
apply (erule nonempty_exE)
apply (elim conjE exE)
apply (rule_tac x="[[xa -> Pf xa]]F ev" in exI)

apply (rule conjI)
apply (rule_tac x="xa" in exI)
apply (simp)

apply (simp add: Prefixf_eval)
apply (simp add: Prefixf_def)
apply (intro impI)
apply (erule event_in_Ev_X_invE)
apply (blast)

apply (elim conjE exE)
apply (rule_tac x="[[a -> Pf a]]F ev" in exI)

apply (rule conjI)
apply (rule_tac x="a" in exI)
apply (simp)

apply (simp add: Prefixf_eval)
apply (simp add: Prefixf_def)
apply (rule disjI2)
apply (rule_tac x="s" in exI)
apply (simp)
done

(*********************************************************
                     Unique Int bind
 *********************************************************)

lemma eq_Int_bind_unique: 
  "(! :{a} .. Pf) =F<ev> (Pf a)"
apply (simp add: eqsf_decompo)
apply (rule conjI)

apply (simp add: Int_bindt_eval)
apply (rule equalityI)
apply (rule subsetI)
apply (simp)
apply (erule disjE)
apply (simp add: eval_T_in nil_t_in_all_dom)
apply (simp)

apply (rule subsetI)
apply (simp)

apply (simp add: Int_bindf_eval)
done

(*********************************************************
                    empty Int bind
 *********************************************************)

lemma eq_Int_bind_empty: "(! :{} .. Pf) =F<ev> DIV"
apply (simp add: eqsf_decompo)
apply (rule conjI)

apply (simp add: Int_bindt_eval)
apply (simp add: DIVt_eval STOPt_def)

apply (simp add: Int_bindf_eval)
apply (simp add: DIVf_eval)
done

(*********************************************************
                 Int choice idempotence
 *********************************************************)

lemma eq_Int_choice_idem: "P |~| P =F<ev> P"
apply (simp add: eqsf_decompo)
apply (simp add: Int_choicet_eval)
apply (simp add: Int_choicef_eval)
done

end


