           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                July 2004                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_proof_dist2 = Csp_relation_def:

(*****************************************************************

         1. Int choice distribution
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
        Int choice distribution over Rename
 *********************************************************)

(*** trace part ***)

lemma eq_Renamet_dist: 
  "[[(P |~| Q) [[r]]]]T ev = [[(P [[r]]) |~| (Q [[r]])]]T ev"
apply (simp add: Renamet_eval)
apply (simp add: Int_choicet_eval)
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)
apply (blast)
done

(*** failure part ***)

lemma eq_Renamef_dist: 
  "[[(P |~| Q) [[r]]]]F ev = [[(P [[r]]) |~| (Q [[r]])]]F ev"
apply (simp add: Renamef_eval)
apply (simp add: Int_choicef_eval)
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def)
apply (blast)
done

(*** proc ***)

lemma eq_Rename_dist:
  "(P |~| Q) [[r]] =F<ev> (P [[r]]) |~| (Q [[r]])"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Renamet_dist)
apply (simp add: eq_Renamef_dist)
done

(*********************************************************
             Int bind distribution over Rename
 *********************************************************)

(*** trace part ***)

lemma eq_Renamet_Dist: 
  "Y ~= {} ==>
     [[(! :Y .. Pf) [[r]]]]T ev = [[! :Y .. (%x. (Pf x [[r]]))]]T ev"
apply (rule equalityI)

      (* <= *)

apply (rule subsetI)
apply (simp add: Renamet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)

 (* []t *)
 apply (erule disjE)
 apply (simp add: ren_to_nil)

 (* otherwise *)
 apply (elim conjE exE bexE)
 apply (rule disjI2)
 apply (rule_tac x="{t. EX s:[[Pf a]]T ev. ren_check (s, r, t)}" in exI)

 apply (rule conjI)
 apply (rule_tac x="a" in exI)
 apply (simp)

 apply (simp)
 apply (rule_tac x="s" in bexI)
 apply (simp)
 apply (simp)

      (* => *)

apply (rule subsetI)
apply (simp add: Renamet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Renamet_eval)
apply (simp add: Renamet_def)

 (* []t *)
 apply (erule disjE)
 apply (simp add: ren_nil)

 (* otherwise *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (rule_tac x="[[Pf a]]T ev" in exI)

 apply (rule conjI)
 apply (rule_tac x="a" in exI)
 apply (simp_all)
done

(*** failure part ***)

lemma eq_Renamef_Dist: 
  "Y ~= {} ==>
     [[(! :Y .. Pf) [[r]]]]F ev = [[! :Y .. (%x. (Pf x [[r]]))]]F ev"
apply (rule equalityI)

      (* <= *)

apply (rule subsetI)
apply (simp add: Renamef_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def del: split_eta_SetCompr2)
apply (elim conjE exE)
apply (rule_tac x="{(t, X) |t X.
       EX s. ren_check (s, r, t) & (s, <invEv r> X) : [[Pf a]]F ev}" in exI)
apply (rule conjI)
apply (rule_tac x="a" in exI)
apply (simp)

apply (simp)
apply (rule_tac x="s" in exI)
apply (simp)

      (* => *)

apply (rule subsetI)
apply (simp add: Renamef_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Renamef_eval)
apply (simp add: Renamef_def del: split_eta_SetCompr2)
apply (elim conjE exE)
apply (simp del: split_eta_SetCompr2)
apply (elim conjE exE)

apply (rule_tac x="t" in exI)
apply (rule_tac x="X" in exI)
apply (simp)

apply (rule_tac x="s" in exI, simp)
apply (rule_tac x="[[Pf a]]F ev" in exI, simp)
apply (rule_tac x="a" in exI, simp)
done

(*** proc ***)

lemma eq_Rename_Dist: 
  "Y ~= {} ==>
     (! :Y .. Pf) [[r]] =F<ev> ! :Y .. (%x. (Pf x [[r]]))"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Renamet_Dist)
apply (simp add: eq_Renamef_Dist)
done

(*********************************************************
          Int choice distribution over Sequence
 *********************************************************)

(*** trace part ***)

lemma eq_Sequencet_dist: 
    "[[(P1 |~| P2) ;; Q]]T ev 
   = [[(P1 ;; Q) |~| (P2 ;; Q)]]T ev"
apply (simp add: Sequencet_eval)
apply (simp add: Int_choicet_eval)
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (blast)
done

(*** failure part ***)

lemma eq_Sequencef_dist: 
    "[[(P1 |~| P2) ;; Q]]F ev 
   = [[(P1 ;; Q) |~| (P2 ;; Q)]]F ev"
apply (simp add: Sequencef_eval)
apply (simp add: Int_choicef_eval)
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (rule equalityI)

      (* <= *)

apply (rule subsetI)
apply (simp)
apply (erule disjE)

 (* s *)
 apply (simp add: pair_fun_apply)
 apply (erule conjE)
 apply (erule disjE)
 apply (simp)
 apply (simp)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: Int_choicet_eval)
 apply (erule disjE)

  (* P1 *)
  apply (rule disjI2)
  apply (rule disjI1)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

  (* P2 *)
  apply (rule disjI2)
  apply (rule disjI2)
  apply (rule disjI2)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

      (* => *)

apply (rule subsetI)
apply (simp)

 (* s P1 *)
 apply (erule disjE)
 apply (simp add: pair_fun_apply)

 (* P1 ;; Q *)
 apply (erule disjE)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (rule_tac x="s" in exI)
 apply (rule_tac x="t" in exI)
 apply (rule_tac x="X" in exI)
 apply (simp add: Int_choicet_eval)

 (* s P2 *)
 apply (erule disjE)
 apply (simp add: pair_fun_apply)

 (* P2 ;; Q *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (rule_tac x="s" in exI)
 apply (rule_tac x="t" in exI)
 apply (rule_tac x="X" in exI)
 apply (simp add: Int_choicet_eval)
done

(*** proc ***)

lemma eq_Sequence_dist:
  "(P1 |~| P2) ;; Q =F<ev> (P1 ;; Q) |~| (P2 ;; Q)"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Sequencet_dist)
apply (simp add: eq_Sequencef_dist)
done

(*********************************************************
           Int bind distribution over Sequence
 *********************************************************)

(*** trace part ***)

lemma eq_Sequencet_Dist: 
  "X ~= {} ==>
       [[(! :X .. Pf) ;; Q]]T ev 
     = [[! :X .. (%x. (Pf x ;; Q))]]T ev"
apply (rule equalityI)

      (* <= *)

apply (rule subsetI)
apply (simp add: Sequencet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Sequencet_def)
apply (erule disjE)

 (* rmtick *)
 apply (elim conjE exE)
 apply (erule disjE)

  (* []t *)
  apply (simp add: rmtick_nil)

  (* s *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="[[Pf a ;; Q]]T ev" in exI)

  apply (rule conjI)
  apply (rule_tac x="a" in exI)
  apply (simp)

  apply (simp add: Sequencet_eval)
  apply (simp add: Sequencet_def)
  apply (rule disjI1)
  apply (rule_tac x="s" in exI)
  apply (simp)

 (* s @t t *)
 apply (elim conjE exE)
 apply (erule disjE)

  (* []t --> contra *)
  apply (simp add: rmtick_nil)
  apply (simp add: app_t_nil)
  apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)

  (* s *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="[[Pf a ;; Q]]T ev" in exI)
  apply (rule conjI)
  apply (rule_tac x="a" in exI, simp)

  apply (simp add: Sequencet_eval)
  apply (simp add: Sequencet_def)
  apply (rule disjI2)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

      (* => *)

apply (rule subsetI)
apply (simp add: Sequencet_eval)
apply (simp add: Int_bindt_eval)
apply (simp add: Sequencet_eval)
apply (simp add: Sequencet_def)
apply (erule disjE)

 (* []t *)
 apply (rule disjI1)
 apply (rule_tac x="[]t" in exI)
 apply (simp add: rmtick_nil)

 (* s *)
 apply (elim conjE exE)
 apply (simp)
 apply (erule disjE)

  (* rmtick *)
  apply (elim conjE exE)
  apply (rule disjI1)
  apply (rule_tac x="s" in exI)
  apply (simp)
  apply (rule disjI2)
  apply (rule_tac x="[[Pf a]]T ev" in exI, simp)
  apply (rule_tac x="a" in exI, simp)

  (* s @t t *)
  apply (elim conjE exE)
  apply (rule disjI2)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)
  apply (rule disjI2)
  apply (rule_tac x="[[Pf a]]T ev" in exI, simp)
  apply (rule_tac x="a" in exI, simp)
done

(*** failure part ***)

lemma eq_Sequencef_Dist: 
  "X ~= {} ==>
       [[(! :X .. Pf) ;; Q]]F ev 
     = [[! :X .. (%x. (Pf x ;; Q))]]F ev"
apply (rule equalityI)

      (* <= *)

apply (rule subsetI)
apply (simp add: Sequencef_eval)
apply (simp add: Int_bindf_eval)
apply (simp add: Sequencef_def)
apply (erule disjE)

 (* s *)
 apply (simp add: pair_fun_apply)
 apply (elim conjE exE)

 apply (rule_tac x="[[Pf a ;; Q]]F ev" in exI)
 apply (rule conjI)
 apply (rule_tac x="a" in exI, simp)
 apply (simp add: Sequencef_eval)
 apply (simp add: Sequencef_def)

 apply (rule disjI1)
 apply (simp add: pair_fun_apply)

 (* s @t t *)
 apply (elim conjE exE)
 apply (simp add: Int_bindt_eval)
 apply (erule disjE)

  (* []t --> contra *)
  apply (simp add: app_t_nil)
  apply (simp add: nil_in_trace event_in_trace Abs_trace_inject)

  (* s *)
  apply (elim conjE exE)
  apply (rule_tac x="[[Pf a ;; Q]]F ev" in exI)
  apply (rule conjI)

  apply (rule_tac x="a" in exI, simp)
  apply (simp add: Sequencef_eval)
  apply (simp add: Sequencef_def)
  apply (rule disjI2)

  apply (rule_tac x="s" in exI)
  apply (rule_tac x="t" in exI)
  apply (simp)

      (* => *)

apply (rule subsetI)
apply (simp add: Int_bindf_eval)
apply (elim conjE exE)
apply (simp add: Sequencef_eval)
apply (simp add: Sequencef_def)
apply (erule disjE)

 (* s *)
 apply (simp add: pair_fun_apply)
 apply (elim conjE)
 apply (rule disjI1)

 apply (simp add: Int_bindf_eval)
 apply (rule_tac x="[[Pf a]]F ev" in exI)
 apply (simp)
 apply (rule_tac x="a" in exI, simp)

 (* s @t t *)
 apply (elim conjE exE)
 apply (rule disjI2)
 apply (rule_tac x="s" in exI)
 apply (rule_tac x="t" in exI)
 apply (rule_tac x="Xa" in exI)

 apply (simp add: Int_bindt_eval)
 apply (rule disjI2)
 apply (rule_tac x="[[Pf a]]T ev" in exI, simp)
 apply (rule_tac x="a" in exI, simp)
done

(*** proc ***)

lemma eq_Sequence_Dist: 
  "X ~= {} ==>
       (! :X .. Pf) ;; Q =F<ev> ! :X .. (%x. (Pf x ;; Q))"
apply (simp add: eqsf_decompo)
apply (simp add: eq_Sequencet_Dist)
apply (simp add: eq_Sequencef_Dist)
done

end
