           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                August 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Csp_xsymbol = Csp_proof_fp:

(*****************************************************************

         1. X-symbols for Csp
         2.
         3. 
         4. 

 *****************************************************************)

(*------------------------------------*
 |                                    |
 |              X-Symbols             |
 |                                    |
 *------------------------------------*)

syntax (output)
  "_PrefixX"    :: "'a => ('n,'a) proc => ('n,'a) proc"
                                   ("(1_ /-> _)" [150,80] 80)
  "_Ext_prefixX" :: "pttrn => 'a set => ('n,'a) proc => ('n,'a) proc"  
                                   ("(1? _:_ /-> _)" [900,900,80] 80)
  "_Ext_choiceX" :: "('n,'a) proc => ('n,'a) proc => ('n,'a) proc"
                                   ("(1_ /[+] _)" [72,73] 72)
  "_Int_choiceX" :: "('n,'a) proc => ('n,'a) proc => ('n,'a) proc"
                                   ("(1_ /|~| _)" [64,65] 64)
  "_Int_bindX"   :: "pttrn => 'a set => ('n,'a) proc 
                     => ('n,'a) proc"  ("(1! _:_ .. /_)" [900,900,68] 68)
  "_Int_prefixX" :: "pttrn => 'a set => ('n,'a) proc => ('n,'a) proc"  
                                   ("(1! _:_ /-> _)" [900,900,80] 80)

  "_R_Int_bind"  :: "('x => 'a) => pttrn => 'x set =>
                      ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _:_ .. /_)" [900,900,1000,80] 80)
  "_RU_Int_bind" :: "('x => 'a) => pttrn =>
                       ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _ .. /_)" [900,900,80] 80)

syntax (xsymbols)
  "_PrefixX" :: "'a => ('n,'a) proc => ('n,'a) proc"
                          ("(1_ /\<rightarrow> _)" [150,80] 80)
  "_Ext_prefixX" :: "pttrn => 'a set => ('n,'a) proc => ('n,'a) proc"  
                          ("(1? _:_ /\<rightarrow> _)" [900,900,80] 80)
  "_Ext_choiceX" :: "('n,'a) proc => ('n,'a) proc => ('n,'a) proc"
                          ("(1_ /\<box> _)" [72,73] 72)
  "_Int_choiceX" :: "('n,'a) proc => ('n,'a) proc => ('n,'a) proc"
                          ("(1_ /\<sqinter> _)" [64,65] 64)
  "_Int_bindX"   :: "pttrn => 'a set => ('n,'a) proc 
                     => ('n,'a) proc"  ("(1! _:_ \<bullet> /_)" [900,900,68] 68)
  "_Int_prefixX" :: "pttrn => 'a set => ('n,'a) proc => ('n,'a) proc"  
                          ("(1! _:_ /\<rightarrow> _)" [900,900,80] 80)

  "_R_Int_bind"  :: "('x => 'a) => pttrn => 'x set =>
                      ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _:_ \<bullet> /_)" [900,900,1000,80] 80)
  "_RU_Int_bind" :: "('x => 'a) => pttrn =>
                       ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _ \<bullet> /_)" [900,900,80] 80)

translations
  "a \<rightarrow> P"     == "a -> P"
  "? x:X \<rightarrow> P" == "? x:X -> P"
  "P \<box> Q"            == "P [+] Q"
  "P \<sqinter> Q"        == "P |~| Q"
  "! x:X \<bullet> P"     == "! x:X .. P"
  "! x:X \<rightarrow> P" == "! x:X -> P"
  "a !! x:X \<bullet> P"  == "a !! x:X .. P"
  "a !! x \<bullet> P"    == "a !! x:UNIV \<bullet> P"

syntax (output)
  "_I_PrefixX" :: "('x => 'a) => pttrn => 'x set => 
                  ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _:_ /-> _)" [900,900,1000,80] 80)
  "_IU_PrefixX" :: "('x => 'a) => pttrn => ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _ /-> _)" [900,900,80] 80)

  "_S_PrefixX" :: "('x => 'a) => 'x => ('n,'a) proc => ('n,'a) proc" 
                     ("(1_ ! _ /-> _)" [900,1000,80] 80)

  "_R_PrefixX" :: "('x => 'a) => pttrn => 'x set => 
                   ('n,'a) proc => ('n,'a) proc"
                     ("(1_ ? _:_ /-> _)" [900,900,1000,80] 80)
  "_RU_PrefixX" :: "('x => 'a) => pttrn =>
                   ('n,'a) proc => ('n,'a) proc"
                     ("(1_ ? _ /-> _)" [900,900,80] 80)

syntax (xsymbols)
  "_I_PrefixX" :: "('x => 'a) => pttrn => 'x set => 
                  ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _:_ /\<rightarrow> _)" [900,900,1000,80] 80)
  "_IU_PrefixX" :: "('x => 'a) => pttrn => ('n,'a) proc => ('n,'a) proc"
                               ("(1_ !! _ /\<rightarrow> _)" [900,900,80] 80)

  "_S_PrefixX" :: "('x => 'a) => 'x => ('n,'a) proc => ('n,'a) proc" 
                           ("(1_ ! _ /\<rightarrow> _)" [900,1000,80] 80)

  "_R_PrefixX" :: "('x => 'a) => pttrn => 'x set => 
                   ('n,'a) proc => ('n,'a) proc"
                     ("(1_ ? _:_ /\<rightarrow> _)" [900,900,1000,80] 80)
  "_RU_PrefixX" :: "('x => 'a) => pttrn =>
                   ('n,'a) proc => ('n,'a) proc"
                     ("(1_ ? _ /\<rightarrow> _)" [900,900,80] 80)

translations
  "a !! x:X \<rightarrow> P" == "a !! x:X -> P"
  "a !! x \<rightarrow> P"   == "a !! x:UNIV \<rightarrow> P"

  "a ! x \<rightarrow> P"   == "a ! x -> P"
  "a ? x:X \<rightarrow> P" == "a ? x:X -> P"
  "a ? x \<rightarrow> P"   == "a ? x:UNIV \<rightarrow> P"

syntax (output)
  "_NameX" :: "'n => ('n,'a) proc" ("<_>" [0] 90)
  "_TimeoutX"  :: "('n,'a) proc => ('n,'a) proc 
                => ('n,'a) proc"  ("(1_ /[> _)" [73,74] 73)
  "_HidingX"   :: "('n,'a) proc => 'a set => ('n,'a) proc"  
                                        ("(1_ /-- _)" [84,85] 84)
  "_RenameX"   :: "('n,'a) proc => ('a * 'a) set => ('n,'a) proc"  
                                        ("(1_ /[[_]])" [84,0] 84)

syntax (xsymbols)
  "_NameX" :: "'n => ('n,'a) proc" ("\<langle>_\<rangle>" [0] 90)
  "_TimeoutX"  :: "('n,'a) proc => ('n,'a) proc 
                => ('n,'a) proc"  ("(1_ /\<rhd> _)" [73,74] 73)
  "_HidingX"   :: "('n,'a) proc => 'a set => ('n,'a) proc"  
                                        ("(1_ /\<midarrow> _)" [84,85] 84)
  "_RenameX"   :: "('n,'a) proc => ('a * 'a) set => ('n,'a) proc"  
                                        ("(1_ /\<lbrakk>_\<rbrakk>)" [84,0] 84)

translations
  "\<langle>C\<rangle>" == "<C>"
  "P \<rhd> Q"          == "(P |~| STOP) [+] Q"
  "P \<midarrow> X"     == "P -- X"
  "P \<lbrakk>r\<rbrakk>"     == "P [[r]]"

(**************************************************************
                        refinement
 **************************************************************)

syntax (output)
  "_refsfX" :: "('n,'a) proc => ('n,'a) dom_SF_prod
             => ('n,'a) proc => bool"
                   ("(0_ /<=F<_> /_)" [50,0,50] 50)
  "_refsf_rec_inactX" :: "('n,'a) procRec => ('m,'a) procRec => bool"
                   ("(0_ /<=F /_)" [50,50] 50)
  "_refsf_rec_actX" :: "('n,'a) procRec => ('m,'a) procRec => bool"
                   ("(0_ /<=F:active /_)" [50,50] 50)
  "_CHECKrefX" :: "('n,'a) procRec => ('m,'a) procRec => 
                   ('n => ('m,'a) proc) => bool"
                   ("/(2CHECK /_ )/(2<=F /_ )/(2BY /_)" [50,50,50] 50)
  "_CHECKrevX" :: "('n,'a) procRec => ('m,'a) procRec => 
                   ('m => ('n,'a) proc) => bool"
                   ("/(2CHECK /_ )/(2=>F /_ )/(2BY /_)" [50,50,50] 50)

syntax (xsymbols)
  "_refsfX" :: "('n,'a) proc => ('n,'a) dom_SF_prod
             => ('n,'a) proc => bool"
           ("(0_ /\<sqsubseteq>F\<langle>_\<rangle> /_)" [50,0,50] 50)
  "_refsf_rec_inactX" :: "('n,'a) procRec => ('m,'a) procRec => bool"
           ("(0_ /\<sqsubseteq>F /_)" [50,50] 50)
  "_refsf_rec_actX" :: "('n,'a) procRec => ('m,'a) procRec => bool"
           ("(0_ /\<sqsubseteq>F:active /_)" [50,50] 50)
  "_CHECKrefX" :: "('n,'a) procRec => ('m,'a) procRec => 
                   ('n => ('m,'a) proc) => bool"
                   ("/(2CHECK /_ )/(2\<sqsubseteq>F /_ )/(2BY /_)" [50,50,50] 50)
  "_CHECKrevX" :: "('n,'a) procRec => ('m,'a) procRec => 
                   ('m => ('n,'a) proc) => bool"
                   ("/(2CHECK /_ )/(2\<sqsupseteq>F /_ )/(2BY /_)" [50,50,50] 50)

translations
  "P \<sqsubseteq>F\<langle>ev\<rangle> Q" == "P <=F<ev> Q"
  "R1 \<sqsubseteq>F R2"            == "R1 <=F R2"
  "R1 \<sqsubseteq>F:active R2"     == "R1 <=F:active R2"
  "CHECK R1 \<sqsubseteq>F R2 BY f" == "CHECK R1 <=F R2 BY f"
  "CHECK R1 \<sqsupseteq>F R2 BY f" == "CHECK R1 =>F R2 BY f"

end
