           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM07_hide = DM06_hide:

(*****************************************************************

         1. expands hiding operators in Sys
         2.
         3. 
         4. 

 *****************************************************************)

(**************************)
(*** Back0 VAR TH1 HIDE ***)

lemma Back0_VAR_TH1_HIDE: 
  "LET SysDef IN (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Back0 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                  -- (CH0 Un CH1))
        [>
        IF ODD n 
        THEN ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
              -- (CH0 Un CH1))
        ELSE ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
              -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{Back0, RD1 n} Int (CH0 Un CH1) = {RD1 n}")
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Back0_VAR_TH1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Back0_VAR_TH1_HIDE[simplified]]

(**************************)
(*** TH0 VAR Back1 HIDE ***)

lemma TH0_VAR_Back1_HIDE: 
  "LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Back1 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                  -- (CH0 Un CH1))
        [>
        IF EVEN n
        THEN ((Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
              -- (CH0 Un CH1))
        ELSE ((Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
              -- (CH0 Un CH1))"
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{Back1, RD0 n} Int (CH0 Un CH1) = {RD0 n}")
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF TH0_VAR_Back1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF TH0_VAR_Back1_HIDE[simplified]]

(*** Eat0 VAR TH1 HIDE ***)

lemma Eat0_VAR_TH1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
                  -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Eat0 -> ((<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
                  -- (CH0 Un CH1))
        [>
        (Eat0 -> <EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
         -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{Eat0, RD1 n} Int (CH0 Un CH1) = {RD1 n}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF Eat0_VAR_TH1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF Eat0_VAR_TH1_HIDE[simplified]]

(*** TH0 VAR Eat1 HIDE ***)

lemma TH0_VAR_Eat1_HIDE: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        Eat1 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
                 -- (CH0 Un CH1))
        [>
        (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| Eat1 -> <EAT1 n>)
                 -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{Eat1, RD0 n} Int (CH0 Un CH1) = {RD0 n}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF TH0_VAR_Eat1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF TH0_VAR_Eat1_HIDE[simplified]]

(*** EAT0 VAR TH1 HIDE ***)

lemma EAT0_VAR_TH1_HIDE: 
  "EVEN n ==>
   LET SysDef IN (<EAT0 n> |[CH0]| <VAR n> |[CH1]| <TH1>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        End0 -> ((WR0 (n div 2) -> <TH0> |[CH0]| <VAR n> |[CH1]| <TH1>)
                 -- (CH0 Un CH1))
        [>
        (<EAT0 n> |[CH0]| <VAR n> |[CH1]| Back1 -> <TH1>)
         -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{End0, RD1 n} Int (CH0 Un CH1) = {RD1 n}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF EAT0_VAR_TH1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF EAT0_VAR_TH1_HIDE[simplified]]

(*** TH0 VAR EAT1 HIDE ***)

lemma TH0_VAR_EAT1_HIDE: 
  "ODD n ==>
   LET SysDef IN (<TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
                 -- (CH0 Un CH1)
   =F
   LET SysDef IN 
        End1 -> ((<TH0> |[CH0]| <VAR n> |[CH1]| WR1 (3 * n + 1) -> <TH1>)
                 -- (CH0 Un CH1))
        [>
        (Back0 -> <TH0> |[CH0]| <VAR n> |[CH1]| <EAT1 n>)
         -- (CH0 Un CH1)"
apply (tactic {* csp_simp_add_left_tac "unfold_SYS_rules" 1 *})
apply (tactic {* csp_step_left_tac 1 *})
apply (tactic {* csp_light_step_right_tac 1 *})
apply (rule csp_decompo)+
apply (auto)
apply (subgoal_tac "{End1, RD0 n} Int (CH0 Un CH1) = {RD0 n}")
apply (tactic {* csp_simp_add_tac "fold_SYS_rules" 1 *})+
apply (auto)
done

lemmas unfold_SYS_rules = unfold_SYS_rules  
                          csp_rule_rw[OF TH0_VAR_EAT1_HIDE]
lemmas fold_SYS_rules   = fold_SYS_rules    
                          csp_rule_rev_rw[OF TH0_VAR_EAT1_HIDE[simplified]]


end
