           (*-------------------------------------------*
            |                Csp-Prover                 |
            |                August 2004                |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Test_Seq = Csp_Prover:

(*****************************************************************

         1. Test Sequential Composition
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                         event
 *********************************************************)

datatype Event = task1 | task2 | task3 | task4

(*********************************************************
            specification SPC and system SYS
 *********************************************************)

consts 
  Task1 :: "('a, Event) proc"
  Task2 :: "('a, Event) proc"
  Task3 :: "('a, Event) proc"
  Task4 :: "('a, Event) proc"

defs
  Task1_def: "Task1 == task1 -> SKIP"
  Task2_def: "Task2 == task2 -> SKIP"
  Task3_def: "Task3 == task3 -> SKIP"
  Task4_def: "Task4 == task4 -> SKIP"

lemmas Tasks_def = Task1_def Task2_def Task3_def Task4_def

(*********************************************************
            specification SPC and system SYS
 *********************************************************)

consts 
  Spc :: "(NoRec, Event) procRec"
  Sys :: "(NoRec, Event) procRec"

defs
  Spc_def: "Spc == LET-IN     Task1 ;; (    Task2 ;; Task3 ;; Task4
                                        [+] Task3 ;; Task2 ;; Task4)
                          [+] Task3 ;; Task1 ;; Task2 ;; Task4"

  Sys_def: "Sys == LET-IN (Task1 ;; Task2 ||| Task3) ;; Task4"

(*********************************************************
                    SPC =sf SYS
 *********************************************************)

lemma test_seq: "Spc =F Sys"

apply (simp add: Spc_def Sys_def Tasks_def)
apply (auto | tactic {* csp_hnf_tac 1 *})+
done

end
